package org.codehaus.mojo.xmlbeans;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.apache.maven.plugin.AbstractMojo;
import org.apache.maven.plugin.MojoExecutionException;

/**
 * Display help information on xmlbeans-maven-plugin. Call <pre>  mvn xmlbeans:help -Ddetail=true -Dgoal=&lt;goal-name&gt;</pre> to display parameter details.
 *
 * @version generated on Fri Dec 26 14:33:33 CET 2008
 * @goal help
 * @requiresProject false
 */
public class HelpMojo
    extends AbstractMojo
{
    /**
     * If <code>true</code>, display all settable properties for each goal.
     * 
     * @parameter expression="${detail}" default-value="false"
     */
    private boolean detail;

    /**
     * The name of the goal for which to show help. If unspecified, all goals will be displayed.
     * 
     * @parameter expression="${goal}"
     */
    private java.lang.String goal;

    /**
     * The maximum length of a display line.
     * 
     * @parameter expression="${lineLength}" default-value="80"
     */
    private int lineLength;

    /**
     * The number of spaces per indentation level.
     * 
     * @parameter expression="${indentSize}" default-value="2"
     */
    private int indentSize;


    /** {@inheritDoc} */
    public void execute()
        throws MojoExecutionException
    {
        StringBuffer sb = new StringBuffer();

        append( sb, "org.codehaus.mojo:xmlbeans-maven-plugin:2.3.2", 0 );
        append( sb, "", 0 );

        append( sb, "Maven XML Beans Plugin 2.3.2", 0 );
        append( sb, "Runs the xmlbeans parser/code generator against schemas in files and dependent jars.", 1 );
        append( sb, "", 0 );

        if ( goal == null || goal.length() <= 0 )
        {
            append( sb, "This plugin has 3 goals:", 0 );
            append( sb, "", 0 );
        }

        if ( goal == null || goal.length() <= 0 || "help".equals( goal ) )
        {
            append( sb, "xmlbeans:help", 0 );
            append( sb, "Display help information on xmlbeans-maven-plugin. Call\n\u00a0\u00a0mvn\u00a0xmlbeans:help\u00a0-Ddetail=true\u00a0-Dgoal=<goal-name>\nto display parameter details.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "detail (Default: false)", 2 );
                append( sb, "If true, display all settable properties for each goal.", 3 );
                append( sb, "", 0 );

                append( sb, "goal", 2 );
                append( sb, "The name of the goal for which to show help. If unspecified, all goals will be displayed.", 3 );
                append( sb, "", 0 );

                append( sb, "lineLength (Default: 80)", 2 );
                append( sb, "The maximum length of a display line.", 3 );
                append( sb, "", 0 );

                append( sb, "indentSize (Default: 2)", 2 );
                append( sb, "The number of spaces per indentation level.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "xmlbeans".equals( goal ) )
        {
            append( sb, "xmlbeans:xmlbeans", 0 );
            append( sb, "A Maven 2 plugin which parses xsd files and produces a corresponding object model based on the Apache XML Beans parser.\n\n\nThe plugin produces two sets of output files referred to as generated sources and generated classes. The former is then compiled to the build outputDirectory. The latter is generated in this directory.\n\n\nNote that the descriptions for the goal\'s parameters have been blatently copied from http://xmlbeans.apache.org/docs/2.0.0/guide/antXmlbean.html for convenience.\n", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "catalogLocation (Default: ${basedir}/src/main/catalog/resolver-catalog.xml)", 2 );
                append( sb, "The location of the catalog used to resolve xml entities.", 3 );
                append( sb, "", 0 );

                append( sb, "classGenerationDirectory (Default: ${project.build.directory}/generated-classes/xmlbeans)", 2 );
                append( sb, "Set a location to generate CLASS files into.", 3 );
                append( sb, "", 0 );

                append( sb, "compiler", 2 );
                append( sb, "The compiler implementation to use. If this attribute is not set, the value of the build.compiler property, if set, will be used. Otherwise, the default compiler for the current VM will be used.", 3 );
                append( sb, "", 0 );

                append( sb, "debug (Default: false)", 2 );
                append( sb, "Indicates whether source should be compiled with debug information; defaults to off. If set to off, -g:none will be passed on the command line for compilers that support it (for other compilers, no command line argument will be used). If set to true, the value of the debug level attribute determines the command line argument.", 3 );
                append( sb, "", 0 );

                append( sb, "defaultXmlConfigDir (Default: ${basedir}/src/main/xsdconfig)", 2 );
                append( sb, "Default xmlConfigs directory. If no xmlConfigs list is specified, this one is checked automatically.", 3 );
                append( sb, "", 0 );

                append( sb, "download (Default: false)", 2 );
                append( sb, "Set to true to permit the compiler to download URLs for imports and includes. Defaults to false, meaning all imports and includes must be copied locally.", 3 );
                append( sb, "", 0 );

                append( sb, "generatedSchemaDirectory (Default: ${project.build.directory}/xmlbeans-xsds)", 2 );
                append( sb, "The directory where .xsd\'s pulled from xsdJars will be stored.", 3 );
                append( sb, "", 0 );

                append( sb, "javaSource", 2 );
                append( sb, "Returns the javasource parameter which specifies an option to the XmlBeans code generator.", 3 );
                append( sb, "", 0 );

                append( sb, "jaxb (Default: false)", 2 );
                append( sb, "Todo: Unkown use.", 3 );
                append( sb, "", 0 );

                append( sb, "memoryInitialSize", 2 );
                append( sb, "The initial size of the memory for the underlying VM, if javac is run externally; ignored otherwise. Defaults to the standard VM memory setting. (Examples: 83886080, 81920k, or 80m)", 3 );
                append( sb, "", 0 );

                append( sb, "memoryMaximumSize", 2 );
                append( sb, "The maximum size of the memory for the underlying VM, if javac is run externally; ignored otherwise. Defaults to the standard VM memory setting. (Examples: 83886080, 81920k, or 80m)", 3 );
                append( sb, "", 0 );

                append( sb, "noAnn (Default: false)", 2 );
                append( sb, "Ignore annotations", 3 );
                append( sb, "", 0 );

                append( sb, "noJavac (Default: false)", 2 );
                append( sb, "Don\'t compile the generated source files.", 3 );
                append( sb, "", 0 );

                append( sb, "noPvr (Default: false)", 2 );
                append( sb, "Do not enforce the particle valid (restriction) rule.", 3 );
                append( sb, "", 0 );

                append( sb, "noUpa (Default: false)", 2 );
                append( sb, "Do not enforce the unique particle attribution rule.", 3 );
                append( sb, "", 0 );

                append( sb, "noVDoc (Default: false)", 2 );
                append( sb, "do not validate documentation elements", 3 );
                append( sb, "", 0 );

                append( sb, "outputJar", 2 );
                append( sb, "Define the name of the jar file created. For instance, \'myXMLBean.jar\' will output the results of this task into a jar with the same name.", 3 );
                append( sb, "", 0 );

                append( sb, "quiet (Default: true)", 2 );
                append( sb, "Supress the normal amount of console output.", 3 );
                append( sb, "", 0 );

                append( sb, "schemaDirectory (Default: ${basedir}/src/main/xsd)", 2 );
                append( sb, "The directory where .xsd files are to be found.", 3 );
                append( sb, "", 0 );

                append( sb, "sourceGenerationDirectory (Default: ${project.build.directory}/generated-sources/xmlbeans)", 2 );
                append( sb, "Set a location to generate JAVA files into.", 3 );
                append( sb, "", 0 );

                append( sb, "sourceSchemas", 2 );
                append( sb, "A List of source schema files.", 3 );
                append( sb, "", 0 );

                append( sb, "staleFile (Default: ${project.build.directory}/generated-sources/xmlbeans/.staleFlag)", 2 );
                append( sb, "The location of the flag file used to determine if the output is stale.", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "Controls the amount of build message output.", 3 );
                append( sb, "", 0 );

                append( sb, "xmlConfigs", 2 );
                append( sb, "Configuration files used by the object generator. For more information about the format of these files, see Todo.", 3 );
                append( sb, "", 0 );

                append( sb, "xsdJars", 2 );
                append( sb, "List of artifacts whose xsds need to be compiled.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "xmlbeans-test".equals( goal ) )
        {
            append( sb, "xmlbeans:xmlbeans-test", 0 );
            append( sb, "A Maven 2 plugin which parses xsd files and produces a corresponding object model based on the Apache XML Beans parser.\n\n\nThe plugin produces two sets of output files referred to as generated sources and generated classes. The former is then compiled to the build outputDirectory. The latter is generated in this directory.\n\n\nNote that the descriptions for the goal\'s parameters have been blatently copied from http://xmlbeans.apache.org/docs/2.0.0/guide/antXmlbean.html for convenience.\n", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "catalogLocation (Default: ${basedir}/src/main/catalog/resolver-catalog.xml)", 2 );
                append( sb, "The location of the catalog used to resolve xml entities.", 3 );
                append( sb, "", 0 );

                append( sb, "classGenerationDirectory (Default: ${project.build.directory}/generated-classes/test-xmlbeans)", 2 );
                append( sb, "Set a location to generate CLASS files into.", 3 );
                append( sb, "", 0 );

                append( sb, "compiler", 2 );
                append( sb, "The compiler implementation to use. If this attribute is not set, the value of the build.compiler property, if set, will be used. Otherwise, the default compiler for the current VM will be used.", 3 );
                append( sb, "", 0 );

                append( sb, "debug (Default: false)", 2 );
                append( sb, "Indicates whether source should be compiled with debug information; defaults to off. If set to off, -g:none will be passed on the command line for compilers that support it (for other compilers, no command line argument will be used). If set to true, the value of the debug level attribute determines the command line argument.", 3 );
                append( sb, "", 0 );

                append( sb, "defaultXmlConfigDir (Default: ${basedir}/src/test/xsdconfig)", 2 );
                append( sb, "Default xmlConfigs directory. If no xmlConfigs list is specified, this one is checked automatically.", 3 );
                append( sb, "", 0 );

                append( sb, "download (Default: false)", 2 );
                append( sb, "Set to true to permit the compiler to download URLs for imports and includes. Defaults to false, meaning all imports and includes must be copied locally.", 3 );
                append( sb, "", 0 );

                append( sb, "generatedSchemaDirectory (Default: ${project.build.directory}/test-xmlbeans-xsds)", 2 );
                append( sb, "The directory where .xsd\'s pulled from xsdJars will be stored.", 3 );
                append( sb, "", 0 );

                append( sb, "javaSource", 2 );
                append( sb, "Returns the javasource parameter which specifies an option to the XmlBeans code generator.", 3 );
                append( sb, "", 0 );

                append( sb, "jaxb (Default: false)", 2 );
                append( sb, "Todo: Unkown use.", 3 );
                append( sb, "", 0 );

                append( sb, "memoryInitialSize", 2 );
                append( sb, "The initial size of the memory for the underlying VM, if javac is run externally; ignored otherwise. Defaults to the standard VM memory setting. (Examples: 83886080, 81920k, or 80m)", 3 );
                append( sb, "", 0 );

                append( sb, "memoryMaximumSize", 2 );
                append( sb, "The maximum size of the memory for the underlying VM, if javac is run externally; ignored otherwise. Defaults to the standard VM memory setting. (Examples: 83886080, 81920k, or 80m)", 3 );
                append( sb, "", 0 );

                append( sb, "noAnn (Default: false)", 2 );
                append( sb, "Ignore annotations", 3 );
                append( sb, "", 0 );

                append( sb, "noJavac (Default: false)", 2 );
                append( sb, "Don\'t compile the generated source files.", 3 );
                append( sb, "", 0 );

                append( sb, "noPvr (Default: false)", 2 );
                append( sb, "Do not enforce the particle valid (restriction) rule.", 3 );
                append( sb, "", 0 );

                append( sb, "noUpa (Default: false)", 2 );
                append( sb, "Do not enforce the unique particle attribution rule.", 3 );
                append( sb, "", 0 );

                append( sb, "noVDoc (Default: false)", 2 );
                append( sb, "do not validate documentation elements", 3 );
                append( sb, "", 0 );

                append( sb, "outputJar", 2 );
                append( sb, "Define the name of the jar file created. For instance, \'myXMLBean.jar\' will output the results of this task into a jar with the same name.", 3 );
                append( sb, "", 0 );

                append( sb, "quiet (Default: true)", 2 );
                append( sb, "Supress the normal amount of console output.", 3 );
                append( sb, "", 0 );

                append( sb, "schemaDirectory (Default: ${basedir}/src/test/xsd)", 2 );
                append( sb, "The directory where .xsd files are to be found.", 3 );
                append( sb, "", 0 );

                append( sb, "sourceGenerationDirectory (Default: ${project.build.directory}/generated-sources/test-xmlbeans)", 2 );
                append( sb, "Set a location to generate JAVA files into.", 3 );
                append( sb, "", 0 );

                append( sb, "sourceSchemas", 2 );
                append( sb, "A List of source schema files.", 3 );
                append( sb, "", 0 );

                append( sb, "staleFile (Default: ${project.build.directory}/generated-sources/test-xmlbeans/.staleFlag)", 2 );
                append( sb, "The location of the flag file used to determine if the output is stale.", 3 );
                append( sb, "", 0 );

                append( sb, "testXsdJars", 2 );
                append( sb, "List of artifacts whose xsds need to be compiled.", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "Controls the amount of build message output.", 3 );
                append( sb, "", 0 );

                append( sb, "xmlConfigs", 2 );
                append( sb, "Configuration files used by the object generator. For more information about the format of these files, see Todo.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( getLog().isInfoEnabled() )
        {
            getLog().info( sb.toString() );
        }
    }

    /**
     * <p>Repeat a String <code>n</code> times to form a new string.</p>
     *
     * @param str String to repeat
     * @param repeat number of times to repeat str
     * @return String with repeated String
     * @throws NegativeArraySizeException if <code>repeat < 0</code>
     * @throws NullPointerException if str is <code>null</code>
     */
    private static String repeat( String str, int repeat )
    {
        StringBuffer buffer = new StringBuffer( repeat * str.length() );

        for ( int i = 0; i < repeat; i++ )
        {
            buffer.append( str );
        }

        return buffer.toString();
    }

    private void append( StringBuffer sb, String description, int indent )
    {
        for ( Iterator it = toLines( description, indent ).iterator(); it.hasNext(); )
        {
            sb.append( it.next().toString() ).append( '\n' );
        }
    }

    /** 
     * Splits the specified text into lines of convenient display length.
     * 
     * @param text The text to split into lines, must not be <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     * @return The sequence of display lines, never <code>null</code>.
     */
    private List toLines( String text, int indent )
    {
        List lines = new ArrayList();

        String ind = repeat( "\t", indent );
        String[] plainLines = text.split( "(\r\n)|(\r)|(\n)" );
        for ( int i = 0; i < plainLines.length; i++ )
        {
            toLines( lines, ind + plainLines[i] );
        }

        return lines;
    }

    /** 
     * Adds the specified line to the output sequence, performing line wrapping if necessary.
     * 
     * @param lines The sequence of display lines, must not be <code>null</code>.
     * @param line The line to add, must not be <code>null</code>.
     */
    private void toLines( List lines, String line )
    {
        int lineIndent = getIndentLevel( line );
        StringBuffer buf = new StringBuffer( 256 );
        String[] tokens = line.split( " +" );
        for ( int i = 0; i < tokens.length; i++ )
        {
            String token = tokens[i];
            if ( i > 0 )
            {
                if ( buf.length() + token.length() >= lineLength )
                {
                    lines.add( buf.toString() );
                    buf.setLength( 0 );
                    buf.append( repeat( " ", lineIndent * indentSize ) );
                }
                else
                {
                    buf.append( ' ' );
                }
            }
            for ( int j = 0; j < token.length(); j++ )
            {
                char c = token.charAt( j );
                if ( c == '\t' )
                {
                    buf.append( repeat( " ", indentSize - buf.length() % indentSize ) );
                }
                else if ( c == '\u00A0' )
                {
                    buf.append( ' ' );
                }
                else
                {
                    buf.append( c );
                }
            }
        }
        lines.add( buf.toString() );
    }

    /** 
     * Gets the indentation level of the specified line.
     * 
     * @param line The line whose indentation level should be retrieved, must not be <code>null</code>.
     * @return The indentation level of the line.
     */
    private static int getIndentLevel( String line )
    {
        int level = 0;
        for ( int i = 0; i < line.length() && line.charAt( i ) == '\t'; i++ )
        {
            level++;
        }
        for ( int i = level + 1; i <= level + 4 && i < line.length(); i++ )
        {
            if ( line.charAt( i ) == '\t' )
            {
                level++;
                break;
            }
        }
        return level;
    }
}
